/*
   rpc.x -- PIKT piktc & piktc_svc RPCL infile

   $Header: /home/cvs/ucgsb/pikt/src/piktc/rpc.x,v 1.13 1999/07/08 12:40:57 berto Exp $

   This file is part of PIKT ("Problem Informant/Killer Tool").
   Copyright (C) 1998-99 by Robert Osterlund.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   PIKT is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
   USA.

   This product includes software developed by the University of
   California, Berkeley and its contributors.

   Send problem reports, bouquets and brickbats to:

   robert.osterlund@gsb.uchicago.edu

   Robert Osterlund
   Graduate School of Business
   University of Chicago
   1101 E. 58th Street, W309
   Chicago, IL 60637
   USA
 */

typedef string nametype<>;
typedef string dirtype<>;
typedef string exttype<>;
typedef string modetype<>;
typedef string uidtype<>;
typedef string gidtype<>;
typedef string buftype<>;
typedef string hosttype<>;
typedef string rqsttype<>;
typedef string cmdouttype<>;

struct _rfil {
	nametype name;
	dirtype directory;
	exttype extension;
	modetype mode;
	uidtype uid;
	gidtype gid;
	int size;
	buftype text;
};

typedef struct _rfil rfil;

struct _anam {
	nametype name;
	buftype aux;		/* only used by alerts */
	int state;
	struct _anam *next;
};

typedef struct _anam anam;

struct _rqst {
	hosttype hostname;
	rqsttype request;
	int state;
};

typedef struct _rqst rqst;

union execres switch (int result) {
	case 0:
		cmdouttype execcmdout;
	default:
		void;
};

program PIKTCPROG {
	version PIKTCVERS {
		int LIST_FILE(rfil)			= 1;
		int INSTALL_FILE(rfil)			= 2;
		int FETCH_FILE(rfil)			= 3;
		int DELETE_FILE(rfil)			= 4;
		int EDIT_PIKTD_CONF(anam)		= 5;
		int EXECUTE_COMMAND(anam)		= 6;
		execres EXECUTE_COMMANDWAIT(anam)	= 7;
		int FREE_EXECCMDOUT(void)		= 8;
		int EXECUTE_ALERT(anam)			= 9;
		int SHOW_ALERT_STATUS(anam)		= 10;
		int KILL_PIKTD(void)			= 11;
		int KILL_PIKTC_SVC(void)		= 12;
		int RESTART_PIKTD(void)			= 13;
		int RESTART_PIKTC_SVC(void)		= 14;
		int REGISTER_REQUEST(rqst)		= 15;
#ifndef NO_RPC_SVC
		int CALL_BACK(rqst)			= 16;
#endif
	} = 1;
} = RPCPRGNUM;
