%{

/*
   sys.l -- PIKT piktc lexer for the systems.cfg file

   $Header: /home/cvs/ucgsb/pikt/src/piktc/sys.l,v 1.10 1999/10/04 05:18:04 harlan Exp $

   This file is part of PIKT ("Problem Informant/Killer Tool").
   Copyright (C) 1998-99 by Robert Osterlund.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   PIKT is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
   USA.

   This product includes software developed by the University of
   California, Berkeley and its contributors.

   Send problem reports, bouquets and brickbats to:

   robert.osterlund@gsb.uchicago.edu

   Robert Osterlund
   Graduate School of Business
   University of Chicago
   1101 E. 58th Street, W309
   Chicago, IL 60637
   USA
 */

#include "../lib/common.h"
#include "piktc.h"
#include "sys.tab.h"

#define RETURN(token) syslval.sval = strdup(yytext); return token

%}

W		[ \t]
D		[0-9]
L		[A-Za-z]
DL		[0-9A-Za-z]

%option noyywrap

%%

^{L}[-_\.0-9a-zA-Z]*		{ RETURN(_STANZA); }

^#.*(\177)?\n			{ lineno++;
				  syserror("syntax error");
				}

^{W}+hosts			{ return _HOSTS; }

^{W}+members			{ return _MEMBERS; }

^{W}+aliases			{ return _ALIASES; }

{L}[-_\.0-9a-zA-Z]*		{ RETURN(_HOST); }

{W}				{ ; }

(\177)?\n?			{ lineno++; }

.				{ return yytext[0]; }

%%

/* sys error handler
 */
void
syserror (const char *message)
{

	if (stzerr)
		return;
	else {
		stzerr = TRUE;
		fprintf(stderr, "%s, at or near line %d: %s (in sysparse()): %s\n", cfgfilenames[cfgcurr], lineno, message, yytext);
		fflush(stderr);
		bailout = TRUE;
		return;
	}
}
