/*
   timing.c -- PIKT piktd timing routines

   $Header: /home/cvs/ucgsb/pikt/src/piktd/timing.c,v 1.6 1999/10/04 05:22:52 harlan Exp $

   This file is part of PIKT ("Problem Informant/Killer Tool").
   Copyright (C) 1998-99 by Robert Osterlund.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   PIKT is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
   USA.

   This product includes software developed by the University of
   California, Berkeley and its contributors.

   Send problem reports, bouquets and brickbats to:

   robert.osterlund@gsb.uchicago.edu

   Robert Osterlund
   Graduate School of Business
   University of Chicago
   1101 E. 58th Street, W309
   Chicago, IL 60637
   USA
*/

#include "../lib/common.h"
#include "piktd.h"

char *tcp;
unsigned long cb;
int clo, chi, cmin, cmax;

unsigned long himincurr;
unsigned long lomincurr;
unsigned long hrcurr;
unsigned long domcurr;
unsigned long moncurr;
unsigned long dowcurr;

time_t nextmin;

/* given a timing parameter, e.g., "0,1,4,5,6,10-20/2", set up various
   other parameters (e.g., the allowed range for this parameter, 1..12
   in the case of months), before invoking timingparse()
 */
void
parsetiming (char *tim, unsigned long *timeval, int loval, int hival, int minval, int maxval)
{

	clo = loval;
	chi = hival;
	cmin = minval;
	cmax = maxval;
	cb = 0L;
	tcp = tim;
	timingparse();
	*timeval = cb;
}

/* determine the number of seconds until the next minute
 */
void
timingsync ()
{
	register struct tm *tm;

	nextmin = time((time_t*)0);
	tm = localtime(&nextmin);
	nextmin += (60 - tm->tm_sec);
}

/* sleep so as to resync with the next minute
 */
void
timingsleep ()
{
	register int waitsecs;

	waitsecs = (int) (nextmin - time((time_t*)0));
	while (waitsecs > 0)
		waitsecs = (int) sleep((unsigned int) waitsecs);
}
